<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.6.0_65) on Wed Jun 25 14:23:47 JST 2014 -->
<TITLE>
ClientCnxn
</TITLE>

<META NAME="date" CONTENT="2014-06-25">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="ClientCnxn";
    }
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">
<HR>


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../org/apache/zookeeper/AsyncCallback.VoidCallback.html" title="interface in org.apache.zookeeper"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../org/apache/zookeeper/ClientCnxnSocketNIO.html" title="class in org.apache.zookeeper"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../index.html?org/apache/zookeeper/ClientCnxn.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="ClientCnxn.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;<A HREF="#field_summary">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;<A HREF="#field_detail">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
org.apache.zookeeper</FONT>
<BR>
Class ClientCnxn</H2>
<PRE>
java.lang.Object
  <IMG SRC="../../../resources/inherit.gif" ALT="extended by "><B>org.apache.zookeeper.ClientCnxn</B>
</PRE>
<HR>
<DL>
<DT><PRE>public class <B>ClientCnxn</B><DT>extends java.lang.Object</DL>
</PRE>

<P>
This class manages the socket i/o for the client. ClientCnxn maintains a list
 of available servers to connect to and "transparently" switches servers it is
 connected to as needed.
<P>

<P>
<HR>

<P>
<!-- =========== FIELD SUMMARY =========== -->

<A NAME="field_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Field Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ClientCnxn.html#packetLen">packetLen</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../org/apache/zookeeper/client/ZooKeeperSaslClient.html" title="class in org.apache.zookeeper.client">ZooKeeperSaslClient</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ClientCnxn.html#zooKeeperSaslClient">zooKeeperSaslClient</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
</TABLE>
&nbsp;
<!-- ======== CONSTRUCTOR SUMMARY ======== -->

<A NAME="constructor_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Constructor Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ClientCnxn.html#ClientCnxn(java.lang.String, org.apache.zookeeper.client.HostProvider, int, org.apache.zookeeper.ZooKeeper, org.apache.zookeeper.ClientWatchManager, org.apache.zookeeper.ClientCnxnSocket, boolean)">ClientCnxn</A></B>(java.lang.String&nbsp;chrootPath,
           <A HREF="../../../org/apache/zookeeper/client/HostProvider.html" title="interface in org.apache.zookeeper.client">HostProvider</A>&nbsp;hostProvider,
           int&nbsp;sessionTimeout,
           <A HREF="../../../org/apache/zookeeper/ZooKeeper.html" title="class in org.apache.zookeeper">ZooKeeper</A>&nbsp;zooKeeper,
           <A HREF="../../../org/apache/zookeeper/ClientWatchManager.html" title="interface in org.apache.zookeeper">ClientWatchManager</A>&nbsp;watcher,
           org.apache.zookeeper.ClientCnxnSocket&nbsp;clientCnxnSocket,
           boolean&nbsp;canBeReadOnly)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Creates a connection object.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ClientCnxn.html#ClientCnxn(java.lang.String, org.apache.zookeeper.client.HostProvider, int, org.apache.zookeeper.ZooKeeper, org.apache.zookeeper.ClientWatchManager, org.apache.zookeeper.ClientCnxnSocket, long, byte[], boolean)">ClientCnxn</A></B>(java.lang.String&nbsp;chrootPath,
           <A HREF="../../../org/apache/zookeeper/client/HostProvider.html" title="interface in org.apache.zookeeper.client">HostProvider</A>&nbsp;hostProvider,
           int&nbsp;sessionTimeout,
           <A HREF="../../../org/apache/zookeeper/ZooKeeper.html" title="class in org.apache.zookeeper">ZooKeeper</A>&nbsp;zooKeeper,
           <A HREF="../../../org/apache/zookeeper/ClientWatchManager.html" title="interface in org.apache.zookeeper">ClientWatchManager</A>&nbsp;watcher,
           org.apache.zookeeper.ClientCnxnSocket&nbsp;clientCnxnSocket,
           long&nbsp;sessionId,
           byte[]&nbsp;sessionPasswd,
           boolean&nbsp;canBeReadOnly)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Creates a connection object.</TD>
</TR>
</TABLE>
&nbsp;
<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ClientCnxn.html#addAuthInfo(java.lang.String, byte[])">addAuthInfo</A></B>(java.lang.String&nbsp;scheme,
            byte[]&nbsp;auth)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ClientCnxn.html#close()">close</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Close the connection, which includes; send session disconnect to the
 server, shutdown the send/event threads.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ClientCnxn.html#disconnect()">disconnect</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Shutdown the send/event threads.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ClientCnxn.html#enableWrite()">enableWrite</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ClientCnxn.html#getDisableAutoResetWatch()">getDisableAutoResetWatch</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;tests use this to check on reset of watches</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ClientCnxn.html#getLastZxid()">getLastZxid</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ClientCnxn.html#getSessionId()">getSessionId</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;byte[]</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ClientCnxn.html#getSessionPasswd()">getSessionPasswd</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ClientCnxn.html#getSessionTimeout()">getSessionTimeout</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ClientCnxn.html#getXid()">getXid</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ClientCnxn.html#sendPacket(org.apache.jute.Record, org.apache.jute.Record, org.apache.zookeeper.AsyncCallback, int)">sendPacket</A></B>(org.apache.jute.Record&nbsp;request,
           org.apache.jute.Record&nbsp;response,
           <A HREF="../../../org/apache/zookeeper/AsyncCallback.html" title="interface in org.apache.zookeeper">AsyncCallback</A>&nbsp;cb,
           int&nbsp;opCode)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ClientCnxn.html#setDisableAutoResetWatch(boolean)">setDisableAutoResetWatch</A></B>(boolean&nbsp;b)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;tests use this to set the auto reset</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ClientCnxn.html#start()">start</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;ReplyHeader</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ClientCnxn.html#submitRequest(RequestHeader, org.apache.jute.Record, org.apache.jute.Record, org.apache.zookeeper.ZooKeeper.WatchRegistration)">submitRequest</A></B>(RequestHeader&nbsp;h,
              org.apache.jute.Record&nbsp;request,
              org.apache.jute.Record&nbsp;response,
              org.apache.zookeeper.ZooKeeper.WatchRegistration&nbsp;watchRegistration)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.lang.String</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../org/apache/zookeeper/ClientCnxn.html#toString()">toString</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.lang.Object"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class java.lang.Object</B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE>clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait</CODE></TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ============ FIELD DETAIL =========== -->

<A NAME="field_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Field Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="zooKeeperSaslClient"><!-- --></A><H3>
zooKeeperSaslClient</H3>
<PRE>
public <A HREF="../../../org/apache/zookeeper/client/ZooKeeperSaslClient.html" title="class in org.apache.zookeeper.client">ZooKeeperSaslClient</A> <B>zooKeeperSaslClient</B></PRE>
<DL>
<DL>
</DL>
</DL>
<HR>

<A NAME="packetLen"><!-- --></A><H3>
packetLen</H3>
<PRE>
public static final int <B>packetLen</B></PRE>
<DL>
<DL>
</DL>
</DL>

<!-- ========= CONSTRUCTOR DETAIL ======== -->

<A NAME="constructor_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Constructor Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="ClientCnxn(java.lang.String, org.apache.zookeeper.client.HostProvider, int, org.apache.zookeeper.ZooKeeper, org.apache.zookeeper.ClientWatchManager, org.apache.zookeeper.ClientCnxnSocket, boolean)"><!-- --></A><H3>
ClientCnxn</H3>
<PRE>
public <B>ClientCnxn</B>(java.lang.String&nbsp;chrootPath,
                  <A HREF="../../../org/apache/zookeeper/client/HostProvider.html" title="interface in org.apache.zookeeper.client">HostProvider</A>&nbsp;hostProvider,
                  int&nbsp;sessionTimeout,
                  <A HREF="../../../org/apache/zookeeper/ZooKeeper.html" title="class in org.apache.zookeeper">ZooKeeper</A>&nbsp;zooKeeper,
                  <A HREF="../../../org/apache/zookeeper/ClientWatchManager.html" title="interface in org.apache.zookeeper">ClientWatchManager</A>&nbsp;watcher,
                  org.apache.zookeeper.ClientCnxnSocket&nbsp;clientCnxnSocket,
                  boolean&nbsp;canBeReadOnly)
           throws java.io.IOException</PRE>
<DL>
<DD>Creates a connection object. The actual network connect doesn't get
 established until needed. The start() instance method must be called
 subsequent to construction.
<P>
<DL>
<DT><B>Parameters:</B><DD><CODE>chrootPath</CODE> - - the chroot of this client. Should be removed from this Class in ZOOKEEPER-838<DD><CODE>hostProvider</CODE> - the list of ZooKeeper servers to connect to<DD><CODE>sessionTimeout</CODE> - the timeout for connections.<DD><CODE>zooKeeper</CODE> - the zookeeper object that this connection is related to.<DD><CODE>watcher</CODE> - watcher for this connection<DD><CODE>clientCnxnSocket</CODE> - the socket implementation used (e.g. NIO/Netty)<DD><CODE>canBeReadOnly</CODE> - whether the connection is allowed to go to read-only
                mode in case of partitioning
<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE></DL>
</DL>
<HR>

<A NAME="ClientCnxn(java.lang.String, org.apache.zookeeper.client.HostProvider, int, org.apache.zookeeper.ZooKeeper, org.apache.zookeeper.ClientWatchManager, org.apache.zookeeper.ClientCnxnSocket, long, byte[], boolean)"><!-- --></A><H3>
ClientCnxn</H3>
<PRE>
public <B>ClientCnxn</B>(java.lang.String&nbsp;chrootPath,
                  <A HREF="../../../org/apache/zookeeper/client/HostProvider.html" title="interface in org.apache.zookeeper.client">HostProvider</A>&nbsp;hostProvider,
                  int&nbsp;sessionTimeout,
                  <A HREF="../../../org/apache/zookeeper/ZooKeeper.html" title="class in org.apache.zookeeper">ZooKeeper</A>&nbsp;zooKeeper,
                  <A HREF="../../../org/apache/zookeeper/ClientWatchManager.html" title="interface in org.apache.zookeeper">ClientWatchManager</A>&nbsp;watcher,
                  org.apache.zookeeper.ClientCnxnSocket&nbsp;clientCnxnSocket,
                  long&nbsp;sessionId,
                  byte[]&nbsp;sessionPasswd,
                  boolean&nbsp;canBeReadOnly)</PRE>
<DL>
<DD>Creates a connection object. The actual network connect doesn't get
 established until needed. The start() instance method must be called
 subsequent to construction.
<P>
<DL>
<DT><B>Parameters:</B><DD><CODE>chrootPath</CODE> - - the chroot of this client. Should be removed from this Class in ZOOKEEPER-838<DD><CODE>hostProvider</CODE> - the list of ZooKeeper servers to connect to<DD><CODE>sessionTimeout</CODE> - the timeout for connections.<DD><CODE>zooKeeper</CODE> - the zookeeper object that this connection is related to.<DD><CODE>watcher</CODE> - watcher for this connection<DD><CODE>clientCnxnSocket</CODE> - the socket implementation used (e.g. NIO/Netty)<DD><CODE>sessionId</CODE> - session id if re-establishing session<DD><CODE>sessionPasswd</CODE> - session passwd if re-establishing session<DD><CODE>canBeReadOnly</CODE> - whether the connection is allowed to go to read-only
                mode in case of partitioning
<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE></DL>
</DL>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="getSessionId()"><!-- --></A><H3>
getSessionId</H3>
<PRE>
public long <B>getSessionId</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getSessionPasswd()"><!-- --></A><H3>
getSessionPasswd</H3>
<PRE>
public byte[] <B>getSessionPasswd</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getSessionTimeout()"><!-- --></A><H3>
getSessionTimeout</H3>
<PRE>
public int <B>getSessionTimeout</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="toString()"><!-- --></A><H3>
toString</H3>
<PRE>
public java.lang.String <B>toString</B>()</PRE>
<DL>
<DD><DL>
<DT><B>Overrides:</B><DD><CODE>toString</CODE> in class <CODE>java.lang.Object</CODE></DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getDisableAutoResetWatch()"><!-- --></A><H3>
getDisableAutoResetWatch</H3>
<PRE>
public static boolean <B>getDisableAutoResetWatch</B>()</PRE>
<DL>
<DD>tests use this to check on reset of watches
<P>
<DD><DL>

<DT><B>Returns:</B><DD>if the auto reset of watches are disabled</DL>
</DD>
</DL>
<HR>

<A NAME="setDisableAutoResetWatch(boolean)"><!-- --></A><H3>
setDisableAutoResetWatch</H3>
<PRE>
public static void <B>setDisableAutoResetWatch</B>(boolean&nbsp;b)</PRE>
<DL>
<DD>tests use this to set the auto reset
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>b</CODE> - the value to set disable watches to</DL>
</DD>
</DL>
<HR>

<A NAME="start()"><!-- --></A><H3>
start</H3>
<PRE>
public void <B>start</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getLastZxid()"><!-- --></A><H3>
getLastZxid</H3>
<PRE>
public long <B>getLastZxid</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="disconnect()"><!-- --></A><H3>
disconnect</H3>
<PRE>
public void <B>disconnect</B>()</PRE>
<DL>
<DD>Shutdown the send/event threads. This method should not be called
 directly - rather it should be called as part of close operation. This
 method is primarily here to allow the tests to verify disconnection
 behavior.
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="close()"><!-- --></A><H3>
close</H3>
<PRE>
public void <B>close</B>()
           throws java.io.IOException</PRE>
<DL>
<DD>Close the connection, which includes; send session disconnect to the
 server, shutdown the send/event threads.
<P>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE></DL>
</DD>
</DL>
<HR>

<A NAME="getXid()"><!-- --></A><H3>
getXid</H3>
<PRE>
public int <B>getXid</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="submitRequest(RequestHeader, org.apache.jute.Record, org.apache.jute.Record, org.apache.zookeeper.ZooKeeper.WatchRegistration)"><!-- --></A><H3>
submitRequest</H3>
<PRE>
public ReplyHeader <B>submitRequest</B>(RequestHeader&nbsp;h,
                                 org.apache.jute.Record&nbsp;request,
                                 org.apache.jute.Record&nbsp;response,
                                 org.apache.zookeeper.ZooKeeper.WatchRegistration&nbsp;watchRegistration)
                          throws java.lang.InterruptedException</PRE>
<DL>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE>java.lang.InterruptedException</CODE></DL>
</DD>
</DL>
<HR>

<A NAME="enableWrite()"><!-- --></A><H3>
enableWrite</H3>
<PRE>
public void <B>enableWrite</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="sendPacket(org.apache.jute.Record, org.apache.jute.Record, org.apache.zookeeper.AsyncCallback, int)"><!-- --></A><H3>
sendPacket</H3>
<PRE>
public void <B>sendPacket</B>(org.apache.jute.Record&nbsp;request,
                       org.apache.jute.Record&nbsp;response,
                       <A HREF="../../../org/apache/zookeeper/AsyncCallback.html" title="interface in org.apache.zookeeper">AsyncCallback</A>&nbsp;cb,
                       int&nbsp;opCode)
                throws java.io.IOException</PRE>
<DL>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE></DL>
</DD>
</DL>
<HR>

<A NAME="addAuthInfo(java.lang.String, byte[])"><!-- --></A><H3>
addAuthInfo</H3>
<PRE>
public void <B>addAuthInfo</B>(java.lang.String&nbsp;scheme,
                        byte[]&nbsp;auth)</PRE>
<DL>
<DD><DL>
</DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../org/apache/zookeeper/AsyncCallback.VoidCallback.html" title="interface in org.apache.zookeeper"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../org/apache/zookeeper/ClientCnxnSocketNIO.html" title="class in org.apache.zookeeper"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../index.html?org/apache/zookeeper/ClientCnxn.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="ClientCnxn.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;<A HREF="#field_summary">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;<A HREF="#field_detail">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
